processing.app.contrib

## Class AvailableContribution

- Object
- - Contribution
  - - AvailableContribution

-     public class AvailableContribution
      extends Contribution

  A class to hold information about a Contribution that can be downloaded.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class Contribution

      `Contribution.Filter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AvailableContribution(ContributionType type, StringDict params)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ContributionType` | `getType()`
    `LocalContribution` | `install(Base base, File contribArchive, boolean confirmReplace, StatusPanel status)`
    `boolean` | `isInstalled()`
    `boolean` | `writePropertiesFile(File propFile)` We overwrite those fields that aren't proper in the properties file with the curated version from the Processing site.

    - ### Methods inherited from class Contribution

      `getAuthorList, getLastUpdated, getMaxRevision, getMinRevision, getName, getParagraph, getPrettyVersion, getSentence, getTypeName, getUrl, getVersion, isCompatible, isFoundation, loadProperties, loadProperties`

    - ### Methods inherited from class Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AvailableContribution

          public AvailableContribution(ContributionType type,
                                       StringDict params)

  - ### Method Detail

    - #### install

          public LocalContribution install(Base base,
                                           File contribArchive,
                                           boolean confirmReplace,
                                           StatusPanel status)

      Parameters:
        `contribArchive` - a zip file containing the library to install
        `confirmReplace` - true to open a dialog asking the user to confirm removing/moving the library when a library by the same name already exists
        `status` - the StatusPanel. Pass null if this function is called for an install-on-startup
      Returns:

    - #### isInstalled

          public boolean isInstalled()

      Specified by:
        `isInstalled` in class `Contribution`

    - #### getType

          public ContributionType getType()

      Specified by:
        `getType` in class `Contribution`

    - #### writePropertiesFile

          public boolean writePropertiesFile(File propFile)

      We overwrite those fields that aren't proper in the properties file with the curated version from the Processing site. This ensures that things have been cleaned up (for instance, that the "sentence" is really a sentence) and that bad data from the contrib's .properties file doesn't break the manager. However, it also ensures that valid fields in the properties file aren't overwritten, since the properties file may be more recent than the contributions.txt file.
      Parameters:
        `propFile` -
      Returns: